unit Use_Menu;

interface

{
0.001
TEXT AND MENU FUNCTIONS}

Uses
 Use_OpenGL,
 Use_Geometry,
 Global,
 OpenGL;

const
 Max_Texts = 40;

type
 TTextElement = record
  Text:string;
  Action:integer;
  Point:TVect;
  Size:TVect;
  Group:byte;
  alpha:byte;
  Visible:boolean;
  Checked:boolean;
 end;

 TMenu = class
   private
    TECount:integer;
    procedure put_TE(text:TTextElement);
   public
    Shadowed:boolean;
    Text_Color,
    Active_Color,
    Shadow_Color:TPoint;
    Visible_Group:byte;
    TE:array of TTextElement;
    constructor Create;  {rgb text and choosen text color}
    procedure Set_Shadow(r,g,b:byte);{rgb shadow color}
    procedure Set_Color(r,g,b:byte);{rgb text color}
    procedure Set_Active_Color(r,g,b:byte);{rgb active color}
    function add_text_element(Text:string;X,Y,SX,SY:single;Group:byte):integer;
    procedure Anim;
    procedure Render;
    function Check(CX,CY:single;Checked:boolean):integer;
   end;

Var
 Menu:TMenu;

implementation

procedure TMenu.put_TE(text:TTextElement);
begin
 if Text.Checked then
  glColor4f(Self.Active_Color[0],Self.Active_Color[1],Self.Active_Color[2],Text.alpha*0.05) else
   glColor4f(Self.Text_Color[0],Self.Text_Color[1],Self.Text_Color[2],Text.alpha*0.05);
 put_Text(text.Text,text.Point[0],text.Point[1]);
 if Self.Shadowed then {with shadow}
  begin
   glColor4f(Self.Shadow_Color[0],Self.Shadow_Color[1],Self.Shadow_Color[2],Text.alpha*0.025);
   put_Text(text.Text,text.Point[0]+0.05,text.Point[1]-0.05);
  end;
end;

constructor TMenu.Create;
begin
 Self.Shadowed:=false;
 Self.Shadow_Color:=Point(0.2,0.2,0.2);
 Self.Text_Color:=Point(0.5,0.5,0.5);
 Self.Active_Color:=Point(5,0,0);
 TECount:=5;
 SetLength(TE,TECount+1);
end;

procedure TMenu.Set_Shadow(r,g,b:byte);{rgb shadow color}
begin
 Self.Shadowed:=true;
 Self.Shadow_Color:=Point(5*r/255,5*g/255,5*b/255);
end;

procedure TMenu.Set_Color(r,g,b:byte);{rgb text color}
begin
 Self.Text_Color:=Point(5*r/255,5*g/255,5*b/255);
end;

procedure TMenu.Set_Active_Color(r,g,b:byte);{rgb active color}
begin
 Self.Active_Color:=Point(5*r/255,5*g/255,5*b/255);
end;

function TMenu.add_text_element(Text:string;X,Y,SX,SY:single;Group:byte):integer;
Var i:integer;vis:boolean;
begin
 vis:=false;
 for i:=0 to TECount do
  if (TE[i].Text='') then
   begin
    vis:=true;{svobodnoye mesto naydeno}
    break;
   end;
 if not vis then {massiva  nedostatochno}
  begin
   i:=i+1;
   TECount:=TECount+10;{rasshiryaem massiv}
   SetLength(TE,TECount+1);
  end;
 TE[i].Text:=Text;   {addition of new Text element}
 TE[i].Point:=Vector(X,Y);
 TE[i].Size:=Vector(SX,SY);
 TE[i].Group:=Group;
 TE[i].alpha:=255;
 TE[i].Visible:=false;
 TE[i].Checked:=false;
 add_text_element:=i;
end;

procedure TMenu.Anim;
Var i:integer;
begin
 for i:=0 to TECount do      {ne plavnaya animaciya}
  if (TE[i].Group=Self.Visible_Group) then
   TE[i].Visible:=true else           {if Text element in visible Group then make them visible}
   TE[i].Visible:=false;
end;

procedure TMenu.Render;
Var i:integer;
begin
 Self.Anim;
 for i:=0 to TECount do               {drawning}
  if TE[i].Visible then
   put_TE(TE[i]);
end;

function TMenu.Check(CX,CY:single;Checked:boolean):integer;
Var i,Action:integer;
begin
 for i:=0 to TECount do
  if TE[i].Visible then
   if Point_in_Rect(Vector(CX,CY),TE[i].Point,plus(TE[i].Point,TE[i].Size)) then
    begin
     TE[i].Checked:=true;
     Action:=TE[i].Action;
    end else
     TE[i].Checked:=false;
 Check:=Action;
end;

end.
