unit Use_Text;

interface

{
 0.001
 text work module
 menu class}

Uses
 Windows,
 Messages,
 //SysUtils,
 Use_Geometry,
 Use_JPG,
 Use_OpenGl,
 OpenGL;

const
 Max_Texts = 40;

type
 TTextElement = record
  Text:string;
  Action:integer;
  Point:TVect;
  Size:TVect;
  Group:byte;
  alpha:byte;
  Visible:boolean;
  Checked:boolean;
 end;

 TOGLFont = class
    private
    public
    base_Font:integer;
    Max_Font:integer;
    Texture:cardinal;
    W,H,Kern:Single;
    constructor Create(FileName:String);
    procedure Put_Text(Str:string;X,Y:single);  {     }
 end;

 TMenu = class
   private
    TECount:integer;
    procedure put_TE(text:TTextElement);
   public
    Shadowed:boolean;
    Text_Color,
    Active_Color,
    Shadow_Color:TPoint;
    Visible_Group:byte;
    font:TOGLFont;
    TE:array of TTextElement;
    constructor Create(FileName:String);
    procedure Set_Shadow(r,g,b:byte);{rgb shadow color}
    procedure Set_Color(r,g,b:byte);{rgb text color}
    procedure Set_Active_Color(r,g,b:byte);{rgb active color}
    function add_text_element(Text:string;Action:integer;X,Y:single;Group:byte):integer;
    procedure Anim;
    procedure Render;
    function Check(CX,CY:single;Checked:boolean):integer;
   end;

 function IntToStr(X:integer):string;

Var
 Menu:TMenu;

implementation

{------------- font class -----------}


function IntToStr(X:integer):string;
begin
 Str(X, result);
end;

constructor TOGLFont.Create(FileName:String);
begin
 self.Texture:=Random(25000)+25000;
 LoadJPGAlphaTexture(255,255,255,FileName,self.Texture);
 W:=0.32;
 H:=0.32;
 Kern:=0.32;
end;

procedure TOGLFont.Put_Text(Str:string;X,Y:single);  {     }
Var i,num:integer;a,b,c:byte;s:Char;
begin
 {enable}
 glDisable(GL_Depth_Test);
 glEnable(GL_TEXTURE_2D);
 glEnable(GL_BLEND);
 glBindTexture(GL_Texture_2d,self.Texture);
 glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);{  }    
 glPushMatrix();
 glLoadIdentity();
 for i:=1 to Length(Str) do
   begin
     s:=Str[i];
     c:=ord(s);
     case s of
     '0'..'9':begin a:=2;B:=c-48; end;
     'A'..'P':begin a:=10;B:=c-65; end;
     'Q'..'Z':begin a:=9;B:=c-81; end;
     'a'..'p':begin a:=8;B:=c-97; end;
     'q'..'z':begin a:=7;B:=c-113; end;
     ''..'':begin a:=6;B:=c-128; end;
     ''..'':begin a:=5;B:=c-144; end;
     ''..'':begin a:=4;B:=c-160; end;
     ''..'':begin a:=3;B:=c-176; end;
     '!'..'/':begin a:=1;B:=c-33; end;
     '<'..'@':begin a:=0;B:=c-60; end;
     '['..'`':begin a:=0;B:=c-86; end;
     '{'..'~':begin a:=0;B:=c-80; end;{123-126}
     ' ':begin a:=15;b:=15;end;
     end;
    { a:=c mod 16;
     b:=trunc(c/16);  }
     glbegin(GL_Quads);
      gltexcoord2f(a*1/16,b*1/16+1/16);
      glvertex2f(x+(-1+i)*Kern,y);
      gltexcoord2f(a*1/16+1/16,b*1/16+1/16);
      glvertex2f(x+W+(-1+i)*Kern,y);
      gltexcoord2f(a*1/16+1/16,b*1/16);
      glvertex2f(x+W+(-1+i)*Kern,y+H);
      gltexcoord2f(a*1/16,b*1/16);
      glvertex2f(x+(-1+i)*Kern,y+H);
     glend;
   end;
 glPopMatrix();
 glEnable(GL_Depth_Test);
end;


{------------- menu class -----------}

constructor TMenu.Create(FileName:String);
begin
 self.font:=TOGLFont.Create(FileName);
 Self.Shadowed:=false;
 Self.Shadow_Color:=Point(0.2,0.2,0.2);
 Self.Text_Color:=Point(0.5,0.5,0.5);
 Self.Active_Color:=Point(5,0,0);
 TECount:=5;
 SetLength(TE,TECount+1);
end;

procedure TMenu.put_TE(text:TTextElement);
begin
 if Self.Shadowed then {with shadow}
  begin
   glColor4f(Self.Shadow_Color[0],Self.Shadow_Color[1],Self.Shadow_Color[2],Text.alpha*0.025);
   Font.put_Text(text.Text,text.Point[0]+0.05,text.Point[1]-0.05);
  end;
 if Text.Checked then
  glColor4f(Self.Active_Color[0],Self.Active_Color[1],Self.Active_Color[2],Text.alpha*0.05) else
   glColor4f(Self.Text_Color[0],Self.Text_Color[1],Self.Text_Color[2],Text.alpha*0.05);
 Font.put_Text(text.Text,text.Point[0],text.Point[1]);
end;

procedure TMenu.Set_Shadow(r,g,b:byte);{rgb shadow color}
begin
 Self.Shadowed:=true;
 Self.Shadow_Color:=Point(5*r/255,5*g/255,5*b/255);
end;

procedure TMenu.Set_Color(r,g,b:byte);{rgb text color}
begin
 Self.Text_Color:=Point(5*r/255,5*g/255,5*b/255);
end;

procedure TMenu.Set_Active_Color(r,g,b:byte);{rgb active color}
begin
 Self.Active_Color:=Point(5*r/255,5*g/255,5*b/255);
end;

function TMenu.add_text_element(Text:string;Action:integer;X,Y:single;Group:byte):integer;
Var i:integer;vis:boolean;
begin
 vis:=false;
 for i:=0 to TECount do
  if (TE[i].Text='') then
   begin
    vis:=true;{svobodnoye mesto naydeno}
    break;
   end;
 if not vis then {massiva  nedostatochno}
  begin
   i:=i+1;
   TECount:=TECount+10;{rasshiryaem massiv}
   SetLength(TE,TECount+1);
  end;
 TE[i].Text:=Text;   {addition of new Text element}
 TE[i].Action:=Action;
 TE[i].Point:=Vector(X,Y);
 TE[i].Size:=Vector(Self.font.W+Length(Text)*Self.font.Kern,Self.font.H);
 TE[i].Group:=Group;
 TE[i].alpha:=255;
 TE[i].Visible:=false;
 TE[i].Checked:=false;
 add_text_element:=i;
end;

procedure TMenu.Anim;
Var i:integer;
begin
 for i:=0 to TECount do      {ne plavnaya animaciya}
  if (TE[i].Group=Self.Visible_Group) then
   TE[i].Visible:=true else           {if Text element in visible Group then make them visible}
   TE[i].Visible:=false;
end;

procedure TMenu.Render;
Var i:integer;
begin
 Self.Anim;
 for i:=0 to TECount do               {drawning}
  if TE[i].Visible then
   put_TE(TE[i]);
end;

function TMenu.Check(CX,CY:single;Checked:boolean):integer;
Var i,Action:integer;
begin
 for i:=0 to TECount do
  if TE[i].Visible then
   if Point_in_Rect(Vector(CX,CY),TE[i].Point,plus(TE[i].Point,TE[i].Size)) then
    begin
     TE[i].Checked:=true;
     Action:=TE[i].Action;
    end else
     TE[i].Checked:=false;
 Check:=Action;
end;

end.
