// Game.cpp: implementation of the CGame class.
//
//////////////////////////////////////////////////////////////////////

#include "Game.h"
#include "GameAll.h"
#include "PlayerChip.h"
//#include "Enemy.h"

#include <stdio.h>
#include <math.h>

#include "PLD3DEngine\D3DEngine.h"

CD3DEngine Engine;	
extern HWND hWnd;	// from main.cpp
extern LPDIRECT3DDEVICE9       g_pd3dDevice   ; // Our rendering device engine.cpp

#define NUM_MODELS 16			// Number of models in scene.
#define SCREEN_LEFT_PLN -200	// Left border of game screen plane
#define SCREEN_WIDE_PLN 1000	// Wide of game screen plane
#define SCREEN_TOP_PLN 200
#define SCREEN_BOT_PLN -200

//CPlayer Player;
//CEnemy Enemy[MAX_ENEMY];

float GS = 0.0f;

float CHIPS_STEP = 12.5f;
float CHIPS_OFFSET = 44.0f;

CPlayerChip Pl_Chip[2][MAX_CHIPS]; //, En_Chip[MAX_CHIPS];
int Selected_Chip = -1;
int fight_chip = -1;
int Enemy_Player;
CVector dest, i_dest;
CVector MOVE_OFF;
BOOL bSelect = FALSE;
BOOL bFight = FALSE;
int kubik1, kubik2;
BOOL bPLAYER1_WIN = FALSE;
BOOL bPLAYER2_WIN = FALSE;

//int Level[LEVEL_W][LEVEL_H];


float index_360 = 0.0f;


int t_out_x, t_out_y, t_out_l;
char nStats[255];



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGame::CGame()
{
	bDebugInfo = FALSE;
	bPause = FALSE;
	bSlowRender = FALSE;
		//TRUE;
	bMenu = TRUE;
	ActiveMenu = 0;
	bCredits = FALSE;
	gmState = GM_FREE;
	Active_Player = 0;
	
	//Engine.Screen.Width=1280;
	//Engine.Screen.Height=1024;
	//Engine.Screen.FullScreen=TRUE;
	Engine.Screen.Width=700;
	Engine.Screen.Height=600;
}

CGame::~CGame()
{

}

// Func of approximate compare //
bool Approx (float test_num, float res_num, float approx) 
{
	if ((test_num > res_num - approx)&&(test_num < res_num + approx)) return true;
	else return false;
}

// Func of Round (x.1->x, x.6->x+1) //
int Round(float f)
{
	int i = (int)f;
	if ((float)f-i>0.5f) i++;

	return i;
}


int FindLiveChip(int player)
{
	BOOL bExit=FALSE;
	for (int i=0;i<MAX_CHIPS;i++){
		if (Pl_Chip[player][i].str>0){
			sprintf(nStats,"%d playerchip dead. next live chip = %d",player,i);
			//MessageBox(NULL,nStats,"MESS1",MB_OK | MB_ICONINFORMATION);
			bExit = TRUE;
			return i;
			//if (player==0) Selected_Chip = i;
			//if (player==1) fight_chip = i;
		}
	}
	if (!bExit) return 5;
}

void CGame::ChipDead(int d_player, int d_chip)
{
	//MessageBox(NULL,"CGame::ChipDead","MESS",MB_OK | MB_ICONINFORMATION);
	// CHIP DEAD //
	Pl_Chip[d_player][d_chip].str = 0;
	Pl_Chip[d_player][d_chip].x = 9;

	// SELECT NEXT LIVE CHIP //
	if (d_player==0) Selected_Chip = -1; //FindLiveChip(0);
	if (d_player==1) fight_chip = -1; //FindLiveChip(1);
}

void CGame::PlayerFight()
{
	//MessageBox(NULL,"CGame::PlayerFight()","MESS",MB_OK | MB_ICONINFORMATION);
	int n_str, victory_player, vic_chip;
	kubik1 = (rand()%3+1);
	kubik2 = (rand()%3+1);
	int score;
	score = ((Pl_Chip[Active_Player][Selected_Chip].str + 1)*kubik1 
		- Pl_Chip[Enemy_Player][fight_chip].str*kubik2);
	if (score>0) score /= kubik1; else score /= kubik2;

	n_str = score;//(Pl_Chip[Active_Player][Selected_Chip].str + 1) - Pl_Chip[Enemy_Player][fight_chip].str;
	
	sprintf(nStats,"FIGHT! score=%d; kubik1=%d; kubik2=%d", score, kubik1, kubik2);
	//MessageBox(NULL,nStats,"MESS",MB_OK | MB_ICONINFORMATION);
	
	if (n_str>0) { 
		Pl_Chip[Active_Player][Selected_Chip].str = n_str;
		victory_player = Active_Player; 
		vic_chip = Selected_Chip;
		ChipDead(Enemy_Player, fight_chip);
		/*Pl_Chip[Enemy_Player][fight_chip].str = 0;
		Pl_Chip[Enemy_Player][fight_chip].x = 9;*/
		//MessageBox(NULL,"ActPL WIN","MESS1",MB_OK | MB_ICONINFORMATION);
	}
	else {
		Pl_Chip[Enemy_Player][fight_chip].str = -n_str;
		victory_player = Enemy_Player;
		vic_chip = fight_chip;
		ChipDead(Active_Player, Selected_Chip);
		/*Pl_Chip[Active_Player][Selected_Chip].str = 0;
		Pl_Chip[Active_Player][Selected_Chip].x = 9;*/

		//MessageBox(NULL,"EnPL WIN","MESS1",MB_OK | MB_ICONINFORMATION);
	}

	Pl_Chip[victory_player][vic_chip].x = i_dest.x;
	Pl_Chip[victory_player][vic_chip].y = i_dest.y;

	
	gmState = GM_FREE;
	// NEXT PLAYER //
	if (Active_Player==0) Active_Player=1; else Active_Player=0;
	
	Selected_Chip = -1;//FindLiveChip(0);
	fight_chip = -1;//FindLiveChip(1);
}

void CGame::PlayerGo(CVector i_dest_go)
{
	CVector abs_vec, vec, abs_MOVE_OFF;
	
	vec = CVector(Pl_Chip[Active_Player][Selected_Chip].x-i_dest.x, Pl_Chip[Active_Player][Selected_Chip].y-i_dest.y, 0);
	abs_vec = CVector(fabs(vec.x),fabs(vec.y),0);
	abs_MOVE_OFF = CVector(fabs(MOVE_OFF.x),fabs(MOVE_OFF.y),0);
	
	int sum = abs_vec.x + abs_vec.y;
	// TOO FAR MOVE - ERROR //
	if (sum>2) { 
		MOVE_OFF=CVector(0,0,0);
		gmState = GM_FREE;
	} else {
		// ELSE MOVE //
		// Move position to CHIP_STEP //
		if ((abs_MOVE_OFF.x<CHIPS_STEP)||(abs_MOVE_OFF.y<CHIPS_STEP)) MOVE_OFF-= vec * 0.02f*GS;

		// ..Until CHIP_STEP //
		if ((Approx(abs_MOVE_OFF.x,(float)CHIPS_STEP,2)||(Approx(abs_MOVE_OFF.y,(float)CHIPS_STEP,2)))){
			
			MOVE_OFF=CVector(0,0,0);
			
			if (gmState != GM_FIGHT){
				Pl_Chip[Active_Player][Selected_Chip].x = i_dest.x;
				Pl_Chip[Active_Player][Selected_Chip].y = i_dest.y;

				gmState = GM_FREE;
				// NEXT PLAYER //
				if (Active_Player==0) Active_Player=1; else Active_Player=0;
			};
			if (gmState == GM_FIGHT) PlayerFight();
			/*Pl_Chip[Active_Player][Selected_Chip].x = i_dest.x;
			Pl_Chip[Active_Player][Selected_Chip].y = i_dest.y;

			gmState = GM_FREE;
			// NEXT PLAYER //
			if (Active_Player==0) Active_Player=1; else Active_Player=0;*/
			/*Selected_Chip = FindLiveChip(0);
			fight_chip = FindLiveChip(1);*/
			Selected_Chip = -1;//FindLiveChip(0);
			fight_chip = -1;//FindLiveChip(1);
		}
	}
}


void NewLevel()
{
	for (int p=0;p<MAX_CHIPS/2;p++){
		// First line
		Pl_Chip[0][p].x = p;
		Pl_Chip[0][p].y = 0;
		Pl_Chip[0][p].str = rand()%5+1;

		// Second line
		Pl_Chip[0][p+8].x = p;
		Pl_Chip[0][p+8].y = 1;
		Pl_Chip[0][p+8].str = 1;

		Selected_Chip = 1;
		fight_chip = 1;

		// First line Enemy
		Pl_Chip[1][p].x = p;
		Pl_Chip[1][p].y = 7;
		Pl_Chip[1][p].str = rand()%5+1;

		// Second line Enemy
		Pl_Chip[1][p+8].x = p;
		Pl_Chip[1][p+8].y = 6;
		Pl_Chip[1][p+8].str = 1;

	}
	/*for (int p=8;p<10;p++){
		Pl_Chip[p].x = p-5;
		Pl_Chip[p].y = 1;
	}*/

	
}


void GenerateLevel()
{
	
	// LOAD LEVEL //
	FILE *filein, *fileout;
	char oneline[255];
	int file_x, file_y, file_typbl;

	if ((filein = fopen("level.lvl", "rt+")) == NULL)
	{
		MessageBox(NULL,"ERROR: NO LEVEL FILE!","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
	} else {
		while (!feof(filein)) {
		//FindStr(filein,"[cos(fi)]");
		ReadStr(filein, oneline);
		sscanf(oneline, "%d;%d;%d;", &file_x,&file_y,&file_typbl); //ReadStr(filein, oneline); Cos_fi = tmp_cf;
		//Global_Level[file_x][file_y]=file_typbl;

		//sprintf(oneline,"%d;%d;%d;", file_x,file_y,file_typbl);
		//MessageBox(NULL,oneline,"DOWN ERROR",MB_OK | MB_ICONINFORMATION);*/
		};
		fclose(filein);
	}

}




void CGame::LoadData()
{

}



void CGame::PressKey()
{
	if (Engine.Keyboard.Key[VK_ESCAPE]) SendMessage(hWnd,WM_CLOSE,0,0);
	if (Engine.Keyboard.Key[VK_UP])	{		
		//Engine.Camera.Position.z++;
	}
	if (Engine.Keyboard.Key[VK_DOWN]){
		//Engine.Camera.Position.z--;
	};	
	
	if (Engine.Keyboard.Key[VK_RIGHT])	{
		//Engine.Camera.Position.x++;
	}
	if (Engine.Keyboard.Key[VK_LEFT])	{
		//Engine.Camera.Position.x--;
	}

	if (Engine.Keyboard.Key[VK_SPACE]) { 
	
	}

	if (Engine.Mouse.left_button) {
		if (gmState == GM_FREE) {
		// GET 3D MOUSE CURSOR //
		Engine.Mouse.vPickMesh = Engine.Mouse.Pick3DMesh(Engine.Screen.Width,Engine.Screen.Height,Engine.matView,Engine.XObject[0].Mesh);
		//Engine.XObject[1].Position = Engine.Mouse.vPickMesh + CVector(0,0,Engine.Camera.Position.z);
		dest.x = Engine.Mouse.vPickMesh.x;
		dest.y = Engine.Mouse.vPickMesh.y;
		dest.z = Engine.Mouse.vPickMesh.z;
			
		// CALCULATE I_COORDS //
		i_dest.x = Round((dest.x+CHIPS_OFFSET) / CHIPS_STEP);
		i_dest.y = Round((dest.y+CHIPS_OFFSET) / CHIPS_STEP);
		
		// ACTIVATE PICE OF BOARD //
		bSelect = FALSE;
		bFight = FALSE;
		//CVector i_dest;

		// if ready for select... //
		//if (((Active_Player==0)&&(Selected_Chip==-1))||((Active_Player==1)&&(fight_chip==-1))){
		for(int p=0;p<MAX_CHIPS;p++){
			if ((Pl_Chip[Active_Player][p].x==i_dest.x)&&(Pl_Chip[Active_Player][p].y==i_dest.y)){//&&(Pl_Chip[Active_Player][p].str>0)){
					sprintf(nStats,"1 SELECT CHIP %d", p);
					//MessageBox(NULL,nStats,"MESS1",MB_OK | MB_ICONINFORMATION);
					Selected_Chip = p;
					bSelect = TRUE;

			}
		}
		//} else {
		// If not select (click on enemy (FIGHT)) //
		if ((Selected_Chip!=-1)||(fight_chip!=-1)){
		if (!bSelect) {
			for(int e=0;e<MAX_CHIPS;e++){
				if (Active_Player==0) Enemy_Player=1; else Enemy_Player=0;
				if ((Pl_Chip[Enemy_Player][e].x==i_dest.x)&&(Pl_Chip[Enemy_Player][e].y==i_dest.y)){//&&(Pl_Chip[Active_Player][e].str>0)){
						//ChipsFight(Selected_Chip, e);
						sprintf(nStats,"2 FIGHT CHIP SelCh=%d to FiCh=%d", Selected_Chip, e);
						//MessageBox(NULL,nStats,"MESS2",MB_OK | MB_ICONINFORMATION);
						bFight = TRUE;
						fight_chip = e;
						gmState = GM_FIGHT;
				}
			}
		}
		// If not select or fight (MOVE)
		if ((!bSelect)&&(!bFight)) {
			if ((i_dest.x>-1)&&(i_dest.x<8)&&(i_dest.y>-1)&&(i_dest.y<8)){
				//ChipGo(p);
				gmState = GM_PLAYER_MOVE;
				//MessageBox(NULL,"3 MOVE","MESS3",MB_OK | MB_ICONINFORMATION);
				/*Pl_Chip[Selected_Chip].x = i_dest.x;
				Pl_Chip[Selected_Chip].y = i_dest.y;*/
			}
		}
		}
	}
	}
}


void CGame::Init()
{
	// GAME NEW //
	//GenerateLevel();
	NewLevel();

	// LOAD MODELS //
	Engine.AddXObjects(NUM_MODELS);
	Engine.XObject[0].Load("Models/board.x");
	Engine.XObject[0].SetOrientation(CVector(0,0,0));
	Engine.XObject[0].SetPosition(CVector(0,0,0));
	//Engine.XObject[0].SetTextureMode(1,PL_TEX_SPHERE,PL_D3DTOP_ADDSIGNED2X);
	//Engine.XObject[0].LoadSecondTexture("second.bmp");
	//Engine.XObject[0].Visible=FALSE;

	for(int i=1;i<6;i++){
		sprintf(nStats,"Models/chip%d.x", i);
		Engine.XObject[i].Load(nStats);
		/*Engine.XObject[i].SetOrientation(CVector(0,0,0));
		Engine.XObject[i].SetPosition(CVector(70,0,0));*/

		sprintf(nStats,"Models/chipC%d.x", i);
		Engine.XObject[i+5].Load(nStats);
		//MessageBox(NULL,nStats,"DOWN ERROR",MB_OK | MB_ICONINFORMATION);
	}

	
	
	// INIT FONTS //
	Engine.InitFonts(3);
	Engine.AddTxtBlocks(18);
	Engine.TxtBlock[0].Set(0,10,50,D3DCOLOR_ARGB(100,10,30,110),"!");
	Engine.ChangeFont(1,"Arial",20, 1L);
	Engine.ChangeFont(2,"Arial",32, 1L);

	// SET CAMERA //
	Engine.Camera.SetWide(50.0f);
	Engine.Camera.SetPosition(CVector(0,0,-140));
	Engine.Camera.SetDistanse(1, 500);

	Engine.Fps.SetPoint();

	

}

void CGame::DrawAll()
{
	// Set Camera //
	Engine.Camera.SetOrientation(CVector((Active_Player)*2-1,0,0));

	// Draw Table //
	for(int i=0;i<5;i++){
		Engine.XObject[1+i].SetPosition(CVector(59,-i*12+25,0));
		Engine.XObject[1+i].Draw(NULL);

		Engine.XObject[6+i].SetPosition(CVector(70,-i*12+25,0));
		Engine.XObject[6+i].Draw(NULL);
		
		Engine.TxtBlock[6+i].bScaled=TRUE;
		Engine.TxtBlock[6+i].color3d=CVector(1,1,0);
		Engine.TxtBlock[6+i].z=-5;

		sprintf(nStats, "%d", i+1);
		Engine.TxtBlock[6+i].Set(2, 61, -i*11.8f+27, D3DCOLOR_XRGB(250,250,120), nStats);

		
	}

	// Draw Kubs //
	if (bFight==TRUE) {
		Engine.TxtBlock[13].bScaled=TRUE;
		Engine.TxtBlock[13].color3d=CVector(1,0,0);
		Engine.TxtBlock[13].z=-5;

		Engine.TxtBlock[14].bScaled=TRUE;
		Engine.TxtBlock[14].color3d=CVector(1,1,0);
		Engine.TxtBlock[14].z=-5;

		sprintf(nStats, "+%d", kubik1+1);
		
		Engine.TxtBlock[13].Set(2, 
			Pl_Chip[Active_Player][Selected_Chip].x*CHIPS_STEP-CHIPS_OFFSET+MOVE_OFF.x +CHIPS_STEP/2, 
			Pl_Chip[Active_Player][Selected_Chip].y*CHIPS_STEP-CHIPS_OFFSET+MOVE_OFF.y +CHIPS_STEP/2, 
			D3DCOLOR_XRGB(250,250,120), nStats);
		
		sprintf(nStats, "+%d", kubik2);
		Engine.TxtBlock[14].Set(2, 
			Pl_Chip[Enemy_Player][fight_chip].x*CHIPS_STEP-CHIPS_OFFSET +CHIPS_STEP/2,//+MOVE_OFF.x, 
			Pl_Chip[Enemy_Player][fight_chip].y*CHIPS_STEP-CHIPS_OFFSET +CHIPS_STEP/2,//+MOVE_OFF.y, 
			D3DCOLOR_XRGB(250,250,120), nStats);
	}

	// Draw ALL //
	for(int i=0;i<NUM_MODELS;i++){
		if (Engine.XObject[i].Visible) Engine.XObject[i].Draw(NULL);
	}

	// Draw Board //
	if (Engine.XObject[0].Visible) Engine.XObject[0].Draw(NULL);

	// Draw Chips //
	int N_Model ;
	float z_offset, z_rotate;

	for(int pl=0;pl<2;pl++)
	for(int i=0;i<MAX_CHIPS;i++){
		// Draw Player Chips //
		for (int l=0;l<Pl_Chip[pl][i].str;l++){
			N_Model = l+1;
			if (pl==1) N_Model = l+6;
			Engine.XObject[N_Model].SetPosition(CVector(Pl_Chip[pl][i].x*CHIPS_STEP-CHIPS_OFFSET, Pl_Chip[pl][i].y*CHIPS_STEP-CHIPS_OFFSET, -l));
			//Engine.XObject[N_Model2].SetPosition(CVector(Pl_Chip[1][i].x*CHIPS_STEP-CHIPS_OFFSET, Pl_Chip[1][i].y*CHIPS_STEP-CHIPS_OFFSET, -l));
			if (pl==Active_Player){
				z_offset = (sin(index_360+l*10.0f))-l*2-3;
				z_rotate = sin(index_360+l*10.0f)*5;
				if (Selected_Chip==i){
					Engine.XObject[N_Model].SetOrientation(CVector(0,0,0));
					Engine.XObject[N_Model].SetPosition(CVector(Pl_Chip[pl][i].x*CHIPS_STEP-CHIPS_OFFSET+MOVE_OFF.x, Pl_Chip[pl][i].y*CHIPS_STEP-CHIPS_OFFSET+MOVE_OFF.y, z_offset));
				} else 
					Engine.XObject[N_Model].SetOrientation(CVector(0,0,z_rotate));
				//Engine.XObject[N_Model2].SetPosition(CVector(Pl_Chip[1][i].x*CHIPS_STEP-CHIPS_OFFSET+MOVE_OFF.x, Pl_Chip[1][i].y*CHIPS_STEP-CHIPS_OFFSET+MOVE_OFF.y, z_offset));
			}
			Engine.XObject[N_Model].Draw(NULL);
			//Engine.XObject[N_Model2].Draw(NULL);
		}

	}
	

}


void CGame::Move(float SPEED)
{
	// *** CALCULATE SPEED *** //
	GS = 900.0f / Engine.Fps.framerate; //1000.0f;
	if (GS>150.0f) GS = 1.0f;
	
	if (index_360 < 360.0f) index_360+=0.01f*GS; else index_360=0;

	if (gmState == GM_PLAYER_MOVE) PlayerGo(i_dest);
	if (gmState == GM_FIGHT) PlayerGo(i_dest);// PlayerFight();

}


void CGame::Loop()
{
	//MessageBox(NULL,"ERROR: CP 3","OSHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
	
	char nStats[64];
	
	// LOGIC & MOVE //
	Move(1.0f);
	// SCAN KEY //
	PressKey();

	if (Engine.Fps.GetPoint()>0.0001f){
		Engine.Fps.SetPoint();
	}

	// Calculate sum of str's //
	int score1=0, score2=0;
	for(int i=0;i<MAX_CHIPS;i++){
		score1 += Pl_Chip[Active_Player][i].str;
		score2 += Pl_Chip[Active_Player][i].str;
	};
	if (score1<=0) bPLAYER2_WIN = TRUE;
	if (score2<=0) bPLAYER1_WIN = TRUE;

	// TEXT //
	/*Engine.TxtBlock[0].Set(0, 10,10,D3DCOLOR_XRGB(200,190,50),itoa(Engine.Fps.fps,nStats,10));//nStats);
	Engine.Fps.GetPoint();*/
	
	sprintf(nStats, "PLAYER:%d", Active_Player+1);
	if (Active_Player==1) Engine.TxtBlock[5].Set(1, 540,10,D3DCOLOR_XRGB(Active_Player*250,90,50),nStats);
	else Engine.TxtBlock[5].Set(1, 10,10,D3DCOLOR_XRGB(150,250,50),nStats);
	
	if (bPLAYER1_WIN) Engine.TxtBlock[16].Set(1, 10,30,D3DCOLOR_XRGB(250,250,255),"WIN!");
	if (bPLAYER2_WIN) Engine.TxtBlock[16].Set(1, 550,30,D3DCOLOR_XRGB(250,250,255),"WIN!");
	
	/*sprintf(nStats, "mx=%d my=%d ts=%f gt=%f",Engine.Mouse.position.x,Engine.Mouse.position.y, Engine.Fps.set_point, Engine.Fps.time_elapsed);//Engine.Fps.gt);//set_point);
	Engine.TxtBlock[5].Set(0, 10,80,D3DCOLOR_XRGB(200,190,50),nStats);*/
	
	/*sprintf(nStats, " jump_i= %0.2f; State=%d", Player.jump_index, Player.State);
	Engine.TxtBlock[0].Set(0, 10,50,D3DCOLOR_XRGB(200,190,50),nStats);//nStats);

	sprintf(nStats, "X= %0.2f; Y= %0.2f; Z= %0.2f", 
		Engine.XObject[Player.State].Position.x,Engine.XObject[Player.State].Position.y,Engine.XObject[Player.State].Position.z);
	Engine.TxtBlock[2].Set(1, 10,80,D3DCOLOR_XRGB(100,200,100), nStats); // itoa(Pribor[0].limit,nStats,10));
	sprintf(nStats, "GS=%0.3f", GS);
	Engine.TxtBlock[3].Set(1, 10,110,D3DCOLOR_XRGB(200,50,0), nStats); // itoa(Pribor[0].limit,nStats,10));
	
	//sprintf(nStats, "xi=%d; yi=%d; lev[xi][yi]=%d", t_out_x,t_out_y,t_out_l);
	sprintf(nStats, "bx=%f; by=%f; bool=%d", Player.bullet[0].pos.x,Player.bullet[0].pos.y, Player.bullet[0].b_bullet);
	Engine.TxtBlock[4].Set(1, 10,150,D3DCOLOR_XRGB(0,0,0), nStats); // itoa(Pribor[0].limit,nStats,10));

	sprintf(nStats, " Life= %d", Player.life);
	Engine.TxtBlock[5].Set(0, 10,180,D3DCOLOR_XRGB(200,190,50),nStats);//nStats);*/

/*	sprintf(nStats, "vPx=%0.2f; vPy=%0.2f; vPz=%0.2f", Engine.Mouse.vPickMesh.x,Engine.Mouse.vPickMesh.y,Engine.Mouse.vPickMesh.z);
	Engine.TxtBlock[1].Set(0, 10,120,D3DCOLOR_XRGB(200,19,50),nStats);//nStats);

	sprintf(nStats, "sx=%f; sy=%f; sel=%d; str=%d;", 
		Pl_Chip[Selected_Chip].x*CHIPS_STEP-CHIPS_OFFSET,Pl_Chip[Selected_Chip].y*CHIPS_STEP-CHIPS_OFFSET, Selected_Chip, Pl_Chip[Selected_Chip].str);
	Engine.TxtBlock[2].Set(0, 10,150,D3DCOLOR_XRGB(0,200,0), nStats); // itoa(Pribor[0].limit,nStats,10));

	sprintf(nStats, "six=%d; siy=%d;", Round((dest.x+CHIPS_OFFSET)/CHIPS_STEP), Round((dest.y+CHIPS_OFFSET)/CHIPS_STEP));
	Engine.TxtBlock[3].Set(0, 10,170,D3DCOLOR_XRGB(0,200,0), nStats); // itoa(Pribor[0].limit,nStats,10));
	
	sprintf(nStats, "sixf=%f; siyf=%f;", (dest.x+CHIPS_OFFSET)/CHIPS_STEP, (dest.y+CHIPS_OFFSET)/CHIPS_STEP);
	Engine.TxtBlock[4].Set(0, 10,190,D3DCOLOR_XRGB(0,200,0), nStats); // itoa(Pribor[0].limit,nStats,10));
*/
/*	sprintf(nStats, "sel_x=%d; sel_y=%d; PL=%d; SC=%d; sel_STR=%d", 
		Pl_Chip[Active_Player][Selected_Chip].x,Pl_Chip[Active_Player][Selected_Chip].y, Active_Player, Selected_Chip, Pl_Chip[Active_Player][Selected_Chip].str);
	Engine.TxtBlock[1].Set(0, 10,120,D3DCOLOR_XRGB(200,19,50),nStats);//nStats);

	sprintf(nStats, "idx=%f; idy=%f;", i_dest.x, i_dest.y);
	Engine.TxtBlock[2].Set(0, 10,150,D3DCOLOR_XRGB(0,200,0), nStats); // itoa(Pribor[0].limit,nStats,10));
	
	sprintf(nStats, "Mx=%f; My=%f;", MOVE_OFF.x, MOVE_OFF.y);
	Engine.TxtBlock[3].Set(0, 10,170,D3DCOLOR_XRGB(0,200,0), nStats); // itoa(Pribor[0].limit,nStats,10));

	sprintf(nStats, "bSelect:%d; bFight:%d; gmState:%d",bSelect, bFight, gmState);
	Engine.TxtBlock[4].Set(0, 10,190,D3DCOLOR_XRGB(0,200,0), nStats); // itoa(Pribor[0].limit,nStats,10));
*/
	
	// LOGIC //
	int step = 30;
	int Pr_lx[2];
	Pr_lx[0] = 105;
	Pr_lx[1] = 355;

	CVector vInd;

	// DRAW //
	Engine.Fps.Calculate();
	Engine.StartDraw();
	DrawAll();
	Engine.Render();
	Engine.EndDraw();
	

}