// Camera.cpp: implementation of the CCamera class.
//
//////////////////////////////////////////////////////////////////////

#include "Camera.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCamera::CCamera()
{
	Position = CVector(0.0f,0.0f,-40.0f);
	LookAt = CVector(0.0f,0.0f,10.0f);
	Angle = CVector(0.0f,0.0f,0.0f);
	//Angle = CVector(0.0f,0.0f,0.0f);
	Wide = 45.0f;
	DisNear = 1.0f;
	DisFar = 255.0f;

//	bLookAt = TRUE;
}

CCamera::~CCamera()
{

}


void CCamera::SetLookAt(CVector new_LookAt)
{
	LookAt= new_LookAt;	
}


void CCamera::SetPosition(CVector new_pos)
{
	Position = new_pos;	
}


void CCamera::SetOrientation(CVector new_angle)
{
	Angle = new_angle;
//	LookAt = CVector(0,0,10);
//	LookAt = Position + CVector(sin(Angle.x/57.2f), sin(Angle.y/57.2f), sin(Angle.z/57.2f))*10.0f;
}

void CCamera::SetWide(float new_wide)
{
	Wide = new_wide;
}

void CCamera::SetDistanse(float new_near, float new_far)
{
	DisNear = new_near;
	DisFar = new_far;
}


void CCamera::Move(float speed)
{
	CVector Zdir(0,0,1), dir;
	dir = RotatePoint(Zdir, Angle);
	Position += dir * speed;
}

void CCamera::RotateX(float speed)
{
	if (fabs(Angle.x) < 360.0f) Angle.x += speed;
	else Angle.x = 0.0f;
}

void CCamera::RotateY(float speed)
{
	if (fabs(Angle.y) < 360.0f) Angle.y += speed;
	else Angle.y = 0.0f;
}



CVector RotatePoint(CVector p, CVector o_angle)
{
	CVector tmp;
	CVector vtmp;
	CVector angle;
	
	float tx,ty,tz;
	tmp.x = tx = p.x;
	tmp.y = ty = p.y;
	tmp.z = tz = p.z;
	
	angle.x = o_angle.x / 180.0f * 3.14f;
	angle.y = o_angle.y / 180.0f * 3.14f;
	angle.z = o_angle.z / 180.0f * 3.14f;


	// x // 
	if (((int)cos(angle.x)!=1)){//&&((int)angle.x!=0)){
		tmp.x = tx;
		tmp.y = ty * cos(angle.x/180*3.14f) - tz * sin(angle.x);
		tmp.z = ty * sin(angle.x) + tz * cos(angle.x);
	}
	// y // 
	if (((int)cos(angle.y)!=1)){//&&((int)angle.y!=0)){
		tx = tmp.x;
		ty = tmp.y;
		tz = tmp.z;
		tmp.x = tx * cos(angle.y) + tz * sin(angle.y);
		tmp.y = ty;
		tmp.z = tz * cos(angle.y) - tx * sin(angle.y);
	}
	// z // 
	if (((int)cos(angle.z)!=1)){//&&((int)angle.z!=0)){
		tx = tmp.x;
		ty = tmp.y;
		tz = tmp.z;
		tmp.x = tx * cos(angle.z) - ty * sin(angle.z);
		tmp.y = ty * cos(angle.z) + tx * sin(angle.z);
		tmp.z = tz;
	}
	
	vtmp.x = tmp.x;
	vtmp.y = tmp.y;
	vtmp.z = tmp.z;

	return vtmp;
}
