#include <level.h>

#include <windows.h>
#include <stdio.h>
#include <Box2D.h>


CLevel::CLevel(CCore *engine,HGE *Hge,b2World *MyWorld) {
	hge = Hge;
	Engine = engine;
	World = MyWorld;
	//texBg=Engine->hge->Texture_Load("data/graphics/bg.jpg");
	//sprBg=new hgeSprite(texBg, 0, 0, hge->Texture_GetWidth(texBg), hge->Texture_GetHeight(texBg));
	//sprBg->SetColor(0xffffffff);

	ZeroMemory(Objects, 4 * LEVELOBJECT_MAX);
	DeleteAllObject();
}

CLevel::~CLevel(void) {
	DeleteAllObject();
	hge=0;
	World = NULL;
}

int CLevel::Update(float delta) {	
    int i;
	for(i = 0; i < LEVELOBJECT_MAX; i++) {
		if(Objects[i]!=0) Objects[i]->Update(delta);
	}
	return 0;
}

void CLevel::Render(void) {
	//sprBg->Render(0, 0);

	int i;
	for(i = 0; i < LEVELOBJECT_MAX; i++) {
		if(Objects[i]) Objects[i]->Render();
	}
}

void CLevel::DeleteAllObject(void) {
	int i;
	for(i = 0; i < LEVELOBJECT_MAX; i++) {
		if(Objects[i]) delete Objects[i];
		Objects[i] = 0;
	}
}

int CLevel::AddObject(CGameObject *obj) {
	for(int i = 0; i < LEVELOBJECT_MAX; i++) {
		if(!Objects[i]) {
			Objects[i] = obj;
			Objects[i]->Init();
			return i;
		}
	}
	return -1;
}

int CLevel::AddObjectEnd(CGameObject *obj) {
	for(int i = LEVELOBJECT_MAX-1; i >= 0; i--) {
		if(!Objects[i]) {
			Objects[i] = obj;
			Objects[i]->Init();
			return i;
		}
	}
	return -1;
}

void CLevel::Remove(CGameObject *obj) {
	if(!obj) return;
	for(int i = 0; i < LEVELOBJECT_MAX; i++) {
		if(Objects[i] == obj) {
			delete Objects[i];
			Objects[i] = 0;
			return;
		}
	}
}

bool CLevel::Load(void) {
	DeleteAllObject();

	CGameObject *obj;
	AddObject(obj = new CPall(Engine,hge,World));

	return true;
}
