#include <object.h>
#include <core.h>

#include <hge.h>
#include <hgeresource.h>
#include <hgesprite.h>
#include <hgefont.h>
#include <hgeparticle.h>
#include <Box2D.h>

CPall::CPall(CCore *engine, HGE *Hge ,b2World *MyWorld) : CGameObject(engine,Hge,MyWorld) {
	Timer = 0.f;
	x=200.0f;
	y=200.0f;	
	speed=800.0f;
    friction=1.f;
	Engine=engine;
	hge = Hge;
	World = MyWorld;
	SetBody = NULL;
	isGameOver = false;
	Engine->mouseJoint=NULL;
	Engine->mouseJointIndicator=NULL;

	team[0] = 1;
	team[1] = 2;
	team[2] = 3;	//    
	team[3] = 4;	//  

	CurrentTeam = 0;
	
	b2BodyDef bodyDef;
	/*b2PolygonDef shapeDef;

	bodyDef.position.Set(18.4f, 20.0f);
	bodyDef.linearDamping = 5.0f;
	bodyDef.angularDamping = 1.0f;
	body[0] = World->CreateBody(&bodyDef);
	
	shapeDef.SetAsBox(2.4f, 2.4f);
	shapeDef.density = 10.0f;
	shapeDef.friction = 0.2f;
	shapeDef.restitution = 0.3f;
	shapeDef.filter.groupIndex = 0;
	shape1 = body[0]->CreateShape(&shapeDef);
	body[0]->SetMassFromShapes();
	//float m = body->GetMass(); //~20.5

	for(int i=1;i<6;i++)
	{
	bodyDef.position.Set(20.0f+3.2f*i, 20.0f);
	bodyDef.linearDamping = 0.5f;
	bodyDef.angularDamping = 0.5f;
	body[i] = World->CreateBody(&bodyDef);
	shapeDef.SetAsBox(1.6f, 1.6f);
	shapeDef.density = 2.0f;
	shapeDef.friction = 0.0f;
	shapeDef.restitution = 0.5f;
	shapeDef.filter.groupIndex = -1;
	shape2 = body[i]->CreateShape(&shapeDef);
	body[i]->SetMassFromShapes();
	
	b2RevoluteJointDef jointDef;
	jointDef.body1 = body[i-1];
	jointDef.body2 = body[i];
	if (i==1) jointDef.localAnchor1.Set(4.8,0); else jointDef.localAnchor1.Set(3.2,0);
	jointDef.localAnchor2.Set(0,0);
	World->CreateJoint(&jointDef);
	}*/
	
	hge->Input_GetMousePos(&lastMouseX,&lastMouseY);
	hge->Input_SetMousePos(400,300);
	
	bodyDef.linearDamping = 1.5f;
	bodyDef.angularDamping = 1.5f;
	bodyDef.position.Set(40.0f, 30.0f);
	bodyIndicator = World->CreateBody(&bodyDef);
	b2CircleDef IndicatorShapeDef;
	IndicatorShapeDef.radius = 9.6f;
	IndicatorShapeDef.density = 1.0f;
	IndicatorShapeDef.isSensor = true;
	IndicatorShapeDef.userData = &team[2];
	IndicatorShapeDef.localPosition.Set(0.f,0.f);
	shapeIndicator = bodyIndicator->CreateShape(&IndicatorShapeDef);
	bodyIndicator->SetMassFromShapes();

	bodyDef.position.Set(40.0f, 30.0f);
	bodyField = World->CreateBody(&bodyDef);
	b2PolygonDef FieldShapeDef;
	FieldShapeDef.SetAsBox(25.6f,25.6f);
	FieldShapeDef.isSensor = true;
	FieldShapeDef.userData = &team[3];
	shapeField = bodyField->CreateShape(&FieldShapeDef);
	bodyField->SetMassFromShapes();
	
	bodyDef.linearDamping = 1.5f;
	bodyDef.angularDamping = 1.5f;

	b2CircleDef shapeDef;
	for(int i=0;i<8;i++)
	{
		shapeDef.radius = 3.15f;
		shapeDef.density = 5.0f;
		shapeDef.friction = 0.5f;
		shapeDef.restitution = 0.5f;
		shapeDef.filter.groupIndex = 1;

		bodyDef.position.Set(17.6f+i*6.4f, 7.0f);
		bodys1[i] = World->CreateBody(&bodyDef);
		shapeDef.userData = &team[1];
		shapes1[i] = bodys1[i]->CreateShape(&shapeDef);
		bodys1[i]->SetMassFromShapes();

		bodyDef.position.Set(17.6f+i*6.4f, 51.8f);
		bodys2[i] = World->CreateBody(&bodyDef);
		shapeDef.userData = &team[0];
		shapes2[i] = bodys2[i]->CreateShape(&shapeDef);
		bodys2[i]->SetMassFromShapes();
	}
}

CPall::~CPall(void) {
	Engine = 0;
	for(int i=0;i<8;i++)
	{
		delete par1[i];
		delete par2[i];
	}
	
	delete fnt;
	delete spt;
	delete sprBody;
	Engine->hge->Texture_Free(tex);
	//Engine->hge->Effect_Free(snd);
	hge=0;
}

bool CPall::Init(void) {
		sndSelect=Engine->hge->Effect_Load("data/sound/select.wav");
		sndWinner=Engine->hge->Effect_Load("data/sound/winner.wav");
		tex=Engine->hge->Texture_Load("data/graphics/particles.png");
		texBody=Engine->hge->Texture_Load("data/graphics/box.png");
		if(!sndSelect ||!sndWinner || !tex)
		{
			MessageBox(NULL, "Can't load #1", "Error", MB_OK | MB_ICONERROR | MB_APPLMODAL);
			Engine->hge->System_Shutdown();
			Engine->hge->Release();
			return false;
		}

		sprBody=new hgeSprite(texBody, 0, 0, hge->Texture_GetWidth(texBody), hge->Texture_GetHeight(texBody));
		sprBody->SetColor(0xFF55ccff);
		sprBody->SetHotSpot(hge->Texture_GetWidth(texBody)/2,hge->Texture_GetWidth(texBody)/2);

		fnt=new hgeFont("data/fnt/font1.fnt");

		// Create and set up a particle system
		spt=new hgeSprite(tex, 96, 64, 32, 32);
		spt->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
		spt->SetHotSpot(16,16);
		for(int i=0; i<8; i++)
		{
			par1[i]=new hgeParticleSystem("data/particle/trail.psi",spt);
			par2[i]=new hgeParticleSystem("data/particle/trail.psi",spt);
			par1[i]->Fire();
			par2[i]->Fire();
		}

	return true;
}

void CPall::Update(float delta) {
	b2Vec2 pos;
	for(int i=0; i<8; i++)
	{
		pos = bodys1[i]->GetPosition();
		pos.operator *=(GAME_GLOBAL_SIZE);
		//par->info.nEmission=(int)(dx*dx+dy*dy)*2;
		par1[i]->MoveTo(pos.x,pos.y);
		par1[i]->Update(delta);

		pos = bodys2[i]->GetPosition();
		pos.operator *=(GAME_GLOBAL_SIZE);
		//par->info.nEmission=(int)(dx*dx+dy*dy)*2;
		par2[i]->MoveTo(pos.x,pos.y);
		par2[i]->Update(delta);
	}

	if (isGameOver) return;
	float mx,my;
	hge->Input_GetMousePos(&mx,&my);
	b2Vec2 p(mx/10,my/10);
	
	if ((Engine->mouseJoint==NULL)&&(Engine->mouseJointIndicator==NULL))
	{
		b2MouseJointDef md;
		md.body1 = World->GetGroundBody();
		md.body2 = bodyIndicator;
		md.target = bodyIndicator->GetPosition();
		md.maxForce = speed * bodyIndicator->GetMass();
		Engine->mouseJointIndicator = (b2MouseJoint*)World->CreateJoint(&md);
		bodyIndicator->WakeUp();
	}

	if ((Engine->hge->Input_GetKeyState(HGEK_LBUTTON))&&(Brosok==true))
	{
		if (Engine->mouseJoint) Engine->mouseJoint->SetTarget(p); 

		Brosok = false;
		int i = 0; 
		while (i < Engine->m_pointCount)
		{
			ContactPoint* point = Engine->m_points + i;

			b2Body* tmpBody = point->shape1->GetBody();
			b2Body* tmpBody2 = point->shape2->GetBody();
			
			if ((SetBody==tmpBody)||(SetBody==tmpBody2))
			{
				int *tmp=static_cast<int*>(point->shape1->GetUserData());
				int *tmp2=static_cast<int*>(point->shape2->GetUserData());
				if((*tmp==team[2])||(*tmp2==team[2]))
					Brosok = true;
			}
			i++;
		}
	}
	else
	{
		if (Engine->mouseJoint)
		{
			World->DestroyJoint(Engine->mouseJoint);
			Engine->mouseJoint = NULL;
		}
		if (Engine->mouseJointIndicator) Engine->mouseJointIndicator->SetTarget(p);
	}


	if (Engine->hge->Input_KeyDown(HGEK_LBUTTON))
	{
		if (Engine->mouseJointIndicator)
		{
			World->DestroyJoint(Engine->mouseJointIndicator);
			Engine->mouseJointIndicator = NULL;
		}
		// Make a small box for mouse.
		b2AABB aabb;
		b2Vec2 d;
		d.Set(0.001f, 0.001f);
		aabb.lowerBound = p - d;
		aabb.upperBound = p + d;

		// Query the world for overlapping shapes.
		const int32 k_maxCount = 10;
		b2Shape* shapes[k_maxCount];
		int32 count = World->Query(aabb, shapes, k_maxCount);
		SetBody = NULL;
		for (int32 i = 0; i < count; ++i)
		{
			b2Body* shapeBody = shapes[i]->GetBody();
			if (shapeBody->IsStatic() == false && shapeBody->GetMass() > 0.0f)
			{
				bool inside = shapes[i]->TestPoint(shapeBody->GetXForm(), p);
				if (inside)
				{
					SetBody = shapes[i]->GetBody();
					int *tmp=static_cast<int*>(shapes[i]->GetUserData());
					if (*tmp==team[CurrentTeam])
					{	
						break;
					}else SetBody = NULL;
				}
			}
		}
		if (SetBody)
		{
			Brosok = false;
			int i = 0; 
			while (i < Engine->m_pointCount)
			{
				ContactPoint* point = Engine->m_points + i;

				b2Body* tmpBody = point->shape1->GetBody();
				b2Body* tmpBody2 = point->shape2->GetBody();
				
				if ((SetBody==tmpBody)||(SetBody==tmpBody2))
				{
					int *tmp=static_cast<int*>(point->shape1->GetUserData());
					int *tmp2=static_cast<int*>(point->shape2->GetUserData());
					if((*tmp==team[2])||(*tmp2==team[2]))
						Brosok = true;
				}
				i++;
			}
			if (Brosok)
			{
				hge->Effect_Play(sndSelect);
				if (CurrentTeam == 0)
				{
					CurrentTeam=1;
					//bodyIndicator
				}
				else 
				{
					CurrentTeam=0; 

				}
				b2MouseJointDef md;
				md.body1 = World->GetGroundBody();
				md.body2 = SetBody;
				md.target = SetBody->GetPosition();
				md.maxForce = speed * SetBody->GetMass();
				Engine->mouseJoint = (b2MouseJoint*)World->CreateJoint(&md);
				SetBody->WakeUp();
			}
		}
	} 

	//***isGameOver***\\
	
	if (isGameOver==false)
	{
		flagTeam0Lose = true;
		flagTeam1Lose = true;
		int i = 0; 
		while (i < Engine->m_pointCount)
		{
			ContactPoint* point = Engine->m_points + i;

			b2Body* tmpBody = point->shape1->GetBody();
			b2Body* tmpBody2 = point->shape2->GetBody();
			
			int *tmp=static_cast<int*>(point->shape1->GetUserData());
			int *tmp2=static_cast<int*>(point->shape2->GetUserData());
			if (((*tmp==team[3])||(*tmp2==team[3]))&&((*tmp==team[0])||(*tmp2==team[0])))
			{
				flagTeam0Lose = false;
			}
			if (((*tmp==team[3])||(*tmp2==team[3]))&&((*tmp==team[1])||(*tmp2==team[1])))
			{
				flagTeam1Lose = false;
			}
			i++;
		}
		if (flagTeam0Lose||flagTeam1Lose) 
		{
			isGameOver = true;
			hge->Effect_Play(sndWinner);
		}
	}
}

void CPall::Render(void) {
	for(int i=0; i<8; i++)
	{
		spt->SetColor(0xffff0000);
		par1[i]->Render();
		spt->SetColor(0xff00ff00);
		par2[i]->Render();
	}
	b2Vec2 pos;
	float32 ang;

	hgeQuad quad;
	quad.blend=BLEND_ALPHAADD | BLEND_COLORMUL | BLEND_ZWRITE;
	quad.tex = NULL;
	for(int i=0;i<4;i++) quad.v[i].z=0.5f;
	int iflag = 0;
	for(int i=0;i<8;i++)
	{
		if (iflag == 0) iflag = 1; else iflag = 0;
		for(int j=0;j<8;j++)
		{
			//   
			quad.v[0].x = 144+i*64;		quad.v[0].y = 38+j*64;
			quad.v[1].x = 144+i*64+64;	quad.v[1].y = 38+j*64;
			quad.v[2].x = 144+i*64+64;	quad.v[2].y = 38+j*64+64;
			quad.v[3].x = 144+i*64;		quad.v[3].y = 38+j*64+64;
			
			// 
			if (iflag == 0) iflag = 1; else iflag = 0;
			for(int i=0; i<4; i++)
			if (iflag == 0) quad.v[i].col = 0xFFdddddd;
			else quad.v[i].col=0xFF000000;

			hge->Gfx_RenderQuad(&quad);
		}
	}
	hge->Gfx_RenderLine(144,38,656,38,0xFFdddddd);
	hge->Gfx_RenderLine(144,550,656,550,0xFFdddddd);
	hge->Gfx_RenderLine(144,38,144,550,0xFFdddddd);
	hge->Gfx_RenderLine(656,38,656,550,0xFFdddddd);

	for(int i=0;i<8;i++)
	{	
		pos = bodys1[i]->GetPosition();
		pos.operator *=(GAME_GLOBAL_SIZE);
		ang = bodys1[i]->GetAngle();
		sprBody->SetColor(0xff0000ff);
		sprBody->RenderEx(pos.x,pos.y,ang);
		pos = bodys2[i]->GetPosition();
		pos.operator *=(GAME_GLOBAL_SIZE);
		ang = bodys2[i]->GetAngle();
		sprBody->SetColor(0xffff0000);
		sprBody->RenderEx(pos.x,pos.y,ang);
	}

	if (Engine->mouseJointIndicator) sprBody->SetColor(0x88aaaaaa);
	else sprBody->SetColor(0x8800ff00);
	pos = bodyIndicator->GetPosition();
	pos.operator *=(GAME_GLOBAL_SIZE);
	sprBody->RenderEx(pos.x,pos.y,0,3.f);


	if (isGameOver)
	{
		//   
		quad.v[0].x = 144;	quad.v[0].y = 38;
		quad.v[1].x = 656;	quad.v[1].y = 38;
		quad.v[2].x = 656;	quad.v[2].y = 550;
		quad.v[3].x = 144;	quad.v[3].y = 550;
		
		for(int i=0; i<4; i++) quad.v[i].col=0x88ffffff;

		hge->Gfx_RenderQuad(&quad);

		for (int i=0; i < 16; i++)
		{
			if ((flagTeam0Lose)&&(flagTeam1Lose)) fnt->printf(360+i*3,430-i*20,HGETEXT_CENTER,"All team lose!!!",CurrentTeam+1);
			else if (flagTeam1Lose) 
			{
				fnt->SetColor(0xff000000+(i*0x00110000));
				fnt->printf(360+i*3,430-i*20,HGETEXT_RIGHT,"Team 1",CurrentTeam+1);
				fnt->SetColor(0xff000000+(i*0x00001100));
				fnt->printf(360+i*3,430-i*20,HGETEXT_LEFT," - Winner!!!",CurrentTeam+1);
			}
			else 
			{
				fnt->SetColor(0xff000000+(i*0x00000011));
				fnt->printf(360+i*3,430-i*20,HGETEXT_RIGHT,"Team 2",CurrentTeam+1);
				fnt->SetColor(0xff000000+(i*0x00001100));
				fnt->printf(360+i*3,430-i*20,HGETEXT_LEFT," - Winner!!!",CurrentTeam+1);
			}
		}
		fnt->SetColor(0xff000000);
		fnt->printf(400,50,HGETEXT_CENTER,"Press 'ESCAPE' to exit",CurrentTeam+1);
	} else
	{
		fnt->SetColor(0xffffffff);
		fnt->printf(78,300,HGETEXT_RIGHT,"Team ");
		if (CurrentTeam==0) fnt->SetColor(0xffff0000); else fnt->SetColor(0xff0000ff);
		fnt->printf(78,300,HGETEXT_LEFT,"%d turn",CurrentTeam+1);
		fnt->SetColor(0xff0000ff);
		fnt->printf(700,70,HGETEXT_LEFT,"Team 2");
		fnt->SetColor(0xffff0000);
		fnt->printf(700,530,HGETEXT_LEFT,"Team 1");
	}
}